package TKL::File;

use Data::Dumper;
use TKL;
use strict;
use vars qw(@ISA);

@ISA = qw(TKL);


sub filename {
    return shift->{file};
}


sub get_base {
    my $self = shift;
    my $file = $self->filename;
    my @path = split(/\//, $file);
    
    return pop @path;
}


sub extract_schema {
    my $self = shift;
    my $file = $self->filename;

    my $root = $self->document_element($file);
    my $element_name = $root->nodeName();

    return "$element_name.$TKL::schema_suffix";
}



sub document_element {
    my $self = shift;

    unless (ref($self->{document_element}) eq "XML::LibXML::Node") {
	my $doc_elem = $self->SUPER::document_element($self->filename);
	$self->{document_element} = $doc_elem;
    }

    return $self->{document_element};
}


sub parse {
    my $self = shift;

    return $self->SUPER::parse($self->filename);
}


## $Log: File.pm,v $
## Revision 1.3  2002/12/10 11:18:02  sondberg
## Added method get_base.
##
## Revision 1.2  2002/11/28 21:42:47  sondberg
## Overrides generic parser method.
##
## Revision 1.1  2002/11/27 14:07:38  sondberg
## Added these files to repository.
##

1;
