<?php

if (!function_exists('domxml_open_file')) {
	function domxml_open_file($filename) {
		return xmldocfile($filename);
	}
}

function get_content($node)
{
    $data = "";
    if (is_array($text_nodes = $node->child_nodes())) {
        foreach ($text_nodes as $text_node) {
            $data .= $text_node->content;
        }
    }
    return $data;
}

function get_elements_by_tagname($node,$name)
{
    $r = array();
    if (is_array($child_nodes = $node->child_nodes())) {
        foreach($child_nodes  as $child_node) {
	    if ($child_node->node_type() == XML_ELEMENT_NODE && $child_node->tagname == $name) {
	        array_push($r,$child_node);
	    }
	}
    }
    return $r;
}

foreach (array_merge($_GET, $_POST) as $key => $value) {  // To cope with "register_globals=off" in PHP-4.2.x
    $$key = $value;
}


function dublet_check ($value, $xpath) {
    global $doc_root;
    $socket = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/db/socket";

    if (file_exists($socket)) {
	$yaz = yaz_connect("unix:$socket");
	if (yaz_errno($yaz)) {
	    echo "Kunne ikke forbinde til sgemaskine: ", yaz_error($yaz), "<br>";
	    die;
	}
	yaz_search($yaz, 'rpn', "@attr 1=$xpath $value");
	yaz_wait();
	if (yaz_errno($yaz)) {
	    echo "Kunne ikke sge efter dubletter: ", yaz_error($yaz), "<br>";
	    die;
	}
	if (yaz_hits($yaz)) {
	    return 2;
	} else {
	    return 1;
	}
    } else {
	return 0;
    }
}



function trim_filename ($file) {
    return preg_replace("/\/+/", "/", $file);
}


function makeparms($array, $override = array()) {
    $res='';

    foreach ($array as $varname) {
	$var = &$GLOBALS[$varname];
	if (!empty($var)) {
	    if (!$override[$varname]) {
		if (is_array($GLOBALS[$varname])) {
		    foreach ($var as $key => $member) {
			if ($res)
			    $res .= '&';
			    $res .= "{$varname}[$key]=" . urlencode($member);
		    }
		} else {
		    if ($res)
			$res .= '&';
		    $res .= "$varname=" . urlencode($GLOBALS[$varname]);
		}
	    }
	}
    }
    foreach ($override as $varname => $value) {
	if ($res)
	    $res .= '&';
	$res .= "$varname=" . urlencode($value);
    }
    return $res;
}


function set_value (&$f, $path, $val) {
    $content = $f[array_shift($path)];
    foreach ($path as $entry) {
	$content = $content[$entry];
    }
    $content['value'] = $val;
}


function my_symlink ($target, $link) {
    global $doc_root;
    $root = preg_replace("/\/+$/", "", $_SERVER['DOCUMENT_ROOT'] . "/$doc_root");
    $root_path = preg_split("/\/+/", $root);
    $target_path = preg_split("/\/+/", $target);
    $link_path = preg_split("/\/+/", $link);

    foreach ($root_path as $entry) {
	$target_entry = array_shift($target_path);
	$link_entry = array_shift($link_path);
	if ($entry != $target_entry || $entry != $link_entry) {
	    exception("Path mismatch in entry TARGET='$target_entry', LINK='$link_entry', ROOT='$entry'");
	    die;
	}
    }
    array_pop($link_path);
    foreach ($link_path as $dummy) {
	$rel_target .= "../";
    }
    $rel_target .= join("/", $target_path);
    //echo "<B>REL_TARGET='$rel_target', LINK='$link'</b>";
    return symlink($rel_target, $link);
}




function update_links ($orig_file, $abs_file, $all_links = 0) {
    global $doc_root;

    if (!is_array($all_links)) {
	get_links($_SERVER['DOCUMENT_ROOT'] . "/$doc_root", $all_links = array());
    }
    if (is_array($links = $all_links[$orig_file])) {
	foreach ($links as $link) {
	    system("rm -f $link");
	    if (!my_symlink($abs_file, $link)) {
		exception("Kunne ikke ndre link <em>$link</em> til at pege p <em>$abs_file</em>");
		die;
	    }
	}
    }
}


function unhtmlentities ($string)
{
	$trans_tbl = get_html_translation_table (HTML_ENTITIES);
	$trans_tbl = array_flip ($trans_tbl);
	$trans_tbl[chr(38)] = '&amp;';
	return strtr ($string, $trans_tbl);
}

function get_metadata($url) {
    $fileid = fopen($url, "r");
    $html = fread($fileid, 2048);
    fclose($fileid);
    preg_match_all("/<title>\s*(.*?)</is", $html, $title, PREG_PATTERN_ORDER);
    $meta_tags = get_meta_tags($url);
    $XMLstring .= "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
    $XMLstring .= "<link>\n";
    $XMLstring .= "  <title xml:lang=\"da\">".unhtmlentities($title[1][0])."</title>\n";
    foreach ($meta_tags as $name => $content) {
        preg_match_all("/(dc_)?(.+)/is", $name, $nameArray, PREG_PATTERN_ORDER);
        $XMLstring .= "  <".$nameArray[2][0]." xml:lang=\"da\">".unhtmlentities($content)."</".$nameArray[2][0].">\n";
    }
    $XMLstring .= "</link>\n";
    return $XMLstring;
}

function get_title_old ($xml_file) {		// Attempts to extract a title from an XML record.
    $title = "";
    if (is_array($content = file($xml_file))) {
	$raw = join("", $content);
	if (preg_match("/<dc:title.*?>(.*?)<\/dc:title>/", $raw, $match)) {
	    $title = $match[1];
	} elseif (preg_match("/<title.*?>(.*?)<\/title>/", $raw, $match)) {
	    $title = $match[1];
	}
    }
    return $title;
}

function get_hidden($xml_file) {
    if (preg_match("/<[^?!][^>]*hidden=.1./", join('', file($xml_file))))
	return 1;
    else
	return 0;
}

function get_title ($xml_file, $show_raw=0) {		// Attempts to extract a title from an XML record.
    global $admin_lang;

    if (is_array($content = file($xml_file))) {
	$raw = join("", $content);
	if ($show_raw) {
	    echo "<pre>", htmlentities($raw), "</pre><hr/>";
	}
	if (preg_match_all("/<dc:title\s?(.*?)>(.*?)<\/dc:title>/", $raw, $matches, PREG_SET_ORDER) ||
	   preg_match_all("/<title\s?(.*?)>(.*?)<\/title>/", $raw, $matches, PREG_SET_ORDER)) {
	       foreach ($matches as $match) {
		   if ($show_raw) {
		       echo "MATCH=", count($match), "<br/>";
		       foreach ($match as $key => $entry) {
			   echo "'$key'=>'$entry'<br>";
		       }
		   }
		   if ($attributes = $match[1]) {
		       if (preg_match_all("/(\S+)=\"(.*?)\"/", $attributes, $attr_match, PREG_SET_ORDER)) {
			   foreach ($attr_match as $attr) {
			       if ($attr[1] == "xml:lang" && $attr[2] == $admin_lang) {
				   if ($show_raw) {
				       echo "Returning from 1<br>";
				   }
				   return $match[2];
			       }
			   }
		       }
		   }
	       }
	       if ($show_raw) {
		   echo "Returning from 2: ", $matches[0][2], "<br>";
	       }
	       return $matches[0][2];
	}
    }
}


function get_creator ($xml_file) {
    if ($dom = @domxml_open_file($xml_file)) {
	$root = $dom->document_element();
	return $root->get_attribute("creator");
    } else {
	echo "Kunne ikke parse xml-filen <b>$xml_file</b>";
    }
}


// Browses through a struct by ref, and adds references to dom nodes
function qual_struct (&$p) {
    global $xml_header, $xml_file;

    if (strlen($xml_file)) {
	return;
    }
    $xmlbuf = "$xml_header\n" . create_xml($p);
    if (!($d = domxml_open_mem($xmlbuf))) {
	echo "Can't open/parse raw xml<br><pre>", htmlentities($xmlbuf), "</pre>\n";
	die;
    }
    qual_struct_process ($p, $d->document_element());
}


function qual_struct_process (&$p, $node, $offset=0) {
    $tag = $node->tagname;
    if ($prefix = $node->prefix()) {
	$tag = "$prefix:$tag";
    }

    $p[$tag][$offset]['parent'] = $node;
    if (is_array($kids = $node->child_nodes())) {
	$sub_off = array();
	foreach ($kids as $kid) {
	    if (strlen($subtag = $kid->tagname)) {
		if (!strlen($sub_off[$subtag])) {
		    $sub_off[$subtag] = 0;
		}
		qual_struct_process($p[$tag][$offset]['subtree'], $kid, $sub_off[$subtag] ++);
	    }
	}
    }
}


// Looks for the existence of $file in cwd and up, returns the first occurrence of the file.
function default_file ($file) {
    global $cwd, $debug;
    $current = $cwd;
    $apache = $_SERVER['DOCUMENT_ROOT'];

    while (!file_exists("$apache/$current/$file")) {
	if (file_exists("$apache/$current/tkl.config")) {
	    return 0;
	}
	if (!($current = preg_replace("/\/[^\/]*$/", "", $current))) {
	    return 0;
	}
	if ($debug) {
	    echo "Looking for '$file' in '$apache/$current/$file'<br>";
	}
    }
    if ($debug) {
	echo "Identified $file in '$apache/$current/$file'<br>";
    }
    return "$apache/$current/$file";
}


function get_auto_index () {
    global $dir_config;
    $dir_conf = default_file($dir_config);

    if ($config = file($dir_conf)) {
	foreach ($config as $line) {
	    if (preg_match("/<autoIndex>(.*?)<\/autoIndex>/", $line, $match)) {
		$schema = $match[1];
		if (strlen($schema)) {
		    return $schema;
		}
	    }
	}
    }
    return 0;
}


function make_abs ($file) {
    $target = readlink($file);
    $rel_target_path = preg_split("/\/+/", dirname($target));
    $rel_src_path = preg_split("/\/+/", dirname($file));

    foreach ($rel_target_path as $entry) {
	if (!strlen($entry)) {
	    continue;
	}
	if ($entry == "..") {
	    $pop = array_pop($rel_src_path);
	} else {
	    $rel_src_path[] = $entry;
	}
    }
    return join("/", $rel_src_path) . "/" . basename($target);
}


function get_links ($dir, &$links) {
    if ($dh = @opendir($dir)) {
	while ($entry = readdir($dh)) {
	    if (neglect_file($entry)) {
		continue;
	    }
	    $file = "$dir/$entry";
	    if (is_dir($file)) {
		get_links($file, $links);
	    } else {
		if (is_link($file)) {
		    //$links[realpath(readlink($file))][] = $file;
		    $links[make_abs($file)][] = $file;
		}
	    }
	}
	closedir($dh);
    } else {
	exception("Kunne ikke bne kataloget <em>$dir</em>");
	die;
    }
}


function file_filter ($dir, $filter, &$files, $parms = array(), $recursive = 1) {
    global $suffix_regexp;

    if ($filter && !function_exists($filter)) {
	exception("Filteret <b>$filter</b> findes ikke");
    }
    if ($dh = @opendir($dir)) {
	while ($entry = readdir($dh)) {
	    $file = "$dir/$entry";
	    if (neglect_file($entry)) {
		continue;
	    }
	    if (is_dir($file)) {
		if ($recursive) {
		    file_filter($file, $filter, $files, $parms, $recursive);
		} else {
		    continue;
		}
	    } elseif (!preg_match("/$suffix_regexp$/", $entry)) {
		continue;
	    } elseif (is_link($file)) {
		continue;
	    } else {
		if ($filter) {
		    if ($filter($file, $parms)) {
			$files['passed'][] = $file;
		    } else {
			$files['excluded'][] = $file;
		    }
		} else {
		    $files['passed'][] = $file;
		}
	    }
	}
	closedir($dh);
    } else {
	exception("Kunne ikke bne kataloget <b>$dir</b>");
    }
}


function is_created_by ($file, $parms) {
    if (strlen($creator = get_creator($file))) {
	if ($creator == $parms['login']) {
	    return 1;
	} else {
	    return 0;
	}
    } else {
	return 0;
    }
}


function get_user_files ($dir, $user) {
    $files = array("passed"=>array(), "excluded"=>array());
    file_filter($dir, "is_created_by", $files, array("login"=>$user));
    return $files;
}


function get_files ($dir, $recursive = 0) {
    $files = array("passed"=>array(), "excluded"=>array());
    file_filter($dir, "is_tkl", $files, array(), $recursive);
    return $files;
}


function is_tkl ($file) {   
    return preg_match("/\.tkl$/", $file);
}


function is_empty ($probe_dir) {
    if ($dir = @opendir($probe_dir)) {
	$empty = 1;
	while ($entry = readdir($dir)) {
	    if ($entry == ".." or $entry == ".") {
		continue;
	    }
	    $empty = 0;
	    break;
	}
	closedir($dir);
	return $empty;
    } else {
	    exception("Kataloget '$probe_dir' eksisterer ikke");
    }
}

function escape_amp ($str) {
    $str = str_replace("&amp;", "&", $str);
    return str_replace("&", "&amp;", $str);
}


// Creates well-formed xml-code based on the data structure passed from the form
function create_xml (&$p, $level=0) {
    global $indent;

    $ret = "";
    foreach ($p as $tag => $content) {
    	foreach ($content as $value) {
    	    if (!is_array($value['attr']) && !is_array($value['subtree']) && !strlen($value['value'])) {
    		    continue;
    	    }
    	    $ret .= str_repeat($indent, $level) . "<$tag";
    	    if (is_array($attributes = $value['attr'])) {		// Process attributes if any...
    		    $ret .= make_attr($attributes);
    	    }
    	    $ret .= ">";
    	    if (strlen($value['value'])) {					// Process CDATA
    		    //$ret .= preg_replace("/&/", "&amp;", stripslashes($value['value']));
    		    $ret .= escape_amp(stripslashes($value['value']));
    	    } elseif (is_array($subtree = $value['subtree'])) {		// Process subtree if any...
    		    $ret .= "\n" . create_xml($subtree, $level + 1) . str_repeat($indent, $level);
    	    }
    	    $ret .= "</$tag>\n";
    	}
    }
    return $ret;
}


function get_symb_links ($file) {
}


function set_symb_link ($file, $link) {
}



function create_struct (&$p, $node) {
    // Creates a data structure by reference based upon the content of a dom xml tree

    $tag = $node->tagname;
    if ($prefix = $node->prefix()) {
	    $tag = "$prefix:$tag";
    }
    if (is_array($p[$tag])) {
	    $offset = count($p[$tag]);
    } else {
    	$p[$tag] = array();
    	$offset = 0;
    }
    $p[$tag][$offset]['parent'] = $node;
    if ($attributes = $node->attributes()) {
    	foreach ($attributes as $attr) {
    	    $key = $attr->name();
    	    if ($prefix = $attr->prefix()) {
    		    $key = "$prefix:$key";
    	    }
    	    $p[$tag][$offset]['attr'][$key]['value'] = utf8_decode($attr->value());
    	}
    }
    if (is_array($kids = $node->child_nodes())) {
    	$cdate = "";
    	foreach ($kids as $kid) {
    	    $content = $kid->content;
    	    if ($content) {
		$cdata .= utf8_decode($content);
	    } else {
		create_struct($p[$tag][$offset]['subtree'], $kid);
    	    }
    	}
    	$p[$tag][$offset]['value'] = trim($cdata);
    }
}


// About schemas. IF this function is given a schema-node (it is assumed to be an element)
// it is used to determine whether to collapse sub-tags into a text window or whether to
// handle them as sub-tags. Basically IF there is a schema and IF the element matches
// a schema-element at the current level which is not in itself a sequence, then
// any XML (typically embedded XHTML) is collapsed and shown in the edit window.

function create_struct_old (&$p, $node, $schema_node, $include_empty = 0) {
    // Creates a data structure by reference based upon the content of a dom xml tree

    if ($schema_node)
	$sch_sequence = FALSE;
    else
	$sch_sequence = TRUE; // If we don't have a schema, assume everything is complex

    $sch_children = FALSE;
    if ($schema_node) {
	// We assume we're being called with an element node. Attempt to find a sequence. If not,
	// we must be a primitive element.
	list($sch_elm) = get_elements_by_tagname($schema_node,'complexType');
	if ($sch_elm) {
	    list($sch_sequence) = get_elements_by_tagname($sch_elm,'sequence');
	    if ($sch_sequence)
		$sch_children = $sch_sequence->child_nodes();
	}
    }

    $tag = $node->tagname;
    if ($prefix = $node->prefix()) {
	    $tag = "$prefix:$tag";
    }
    if (is_array($p[$tag])) {
	    $offset = count($p[$tag]);
    } else {
    	$p[$tag] = array();
    	$offset = 0;
    }
    if ($attributes = $node->attributes()) {
    	foreach ($attributes as $attr) {
    	    $key = $attr->name();
    	    if ($prefix = $attr->prefix()) {
    		    $key = "$prefix:$key";
    	    }
    	    $p[$tag][$offset]['attr'][$key]['value'] = utf8_decode($attr->value());
    	}
    }
    if (is_array($kids = $node->child_nodes())) {
    	$cdate = "";
    	foreach ($kids as $kid) {
    	    //$content = trim($kid->content);
    	    $content = $kid->content;
    	    if ($content || $include_empty) {
        		//$p[$tag][$offset]['value'] .= utf8_decode($content);
        		$cdata .= utf8_decode($content);
        	    } else {
			$sch_me = FALSE;
			if ($sch_children) {
			    foreach ($sch_children as $sch_child) {
				if ($sch_child->node_type() == XML_ELEMENT_NODE) {
				    $sch_name = $sch_child->get_attribute('name');
				    if ($sch_name == $kid->tagname()) {
					$sch_me = $sch_child;
					break;
				    }
				}
			    }
			}
        		if (!$sch_sequence) {	// To cope with embedded XHTML
        		    $f = array();
        		    create_struct($f, $kid, FALSE, 1);
        		    $cdata .= trim(create_xml($f, 0, 1));
        		    //$p[$tag][$offset]['value'] .= create_xml($f, 1);
        		} else {
        		    create_struct($p[$tag][$offset]['subtree'], $kid, $sch_me);
        		}
    	    }
    	}
    	$p[$tag][$offset]['value'] = trim($cdata);
    }
    elseif ($include_empty) {
	$p[$tag][$offset]['value'] = '';
    }
}


function get_user_info ($user) {
    global $doc_root, $user_list;
    $apache = $_SERVER['DOCUMENT_ROOT'];
    $user_file = "$apache/$doc_root/$user_list";

    if (!file_exists($user_file)) {
    	exception("Fatal: Kunne ikke finde brugeroplysninger '$user_file'");
    	die;
    }
    $mode = fileperms($user_file);
    if ($mode & 00022) {		// World/group readable?
    	exception("Fatal: Check din lserettighederne for din brugeroplysningsfil");
    	die;
    }
    // Possibly, we want to check for the owner of the user file....
    if (!($dom = domxml_open_file($user_file))) {
    	exception("Kunne ikke bne brugeroplysningsfilen");
    	die;
    }
    $root = $dom->document_element();
    if ($root->tagname != "users") {
    	exception("Ukendt format i brugeroplysningsfil");
    	die;
    }
    if (is_array($user_nodes = $root->child_nodes())) {
    	foreach ($user_nodes as $user_node) {
    	    $user_info = array();
    	    if (is_array($user_info_node = $user_node->child_nodes())) {
        		foreach ($user_info_node as $node) {
        		    if ($node->tagname) {
        			$user_info[$node->tagname] = utf8_decode(get_content($node));
        		    }
        		}
    	    }
    	    if ($user_info['login'] == $user) {
    		    return $user_info;
    	    }
    	}
    }
    return 0;
}


function tainted_path ($path) {
    if (preg_match("/\./", $path)) {
	return "Stien m ikke indholde .";
    }
}


function find_portal_root () {
    global $cwd, $abs_cwd, $doc_root;

    if (isset($cwd)) {
    	if (!($doc_root = check_path($cwd))) {
    	    exception("Udenfor dokumentomrdet");
    	    die;
    	}
    	$abs_cwd = preg_replace("/\/+/", "/", $_SERVER['DOCUMENT_ROOT'] . "/$cwd");
    } else {
    	exception("Husk at angive cwd");
    	die;
    }
}


function neglect_file ($entry) {
    global $xsd_path;
    if ($entry == "." or $entry == ".." or $entry == "CVS" or $entry == "gfx" or $entry == "grafik" or $entry == "db" or $entry == $xsd_path) {
	    return 1;
    } else {
	    return 0;
    }
}


function check_chrs ($str) {
    return preg_replace("/\s/", "\ ", $str);
}


function is_granted ($object, $op) {
    global $doc_root, $debug, $cwd, $this_user, $privileges;

    if ($debug) {
	echo "VALIDATING '$object' FOR ACTION '$op'<br>";
    }

    if (preg_match("/.*\/(.*)$/", $object, $match)) {
	$file = $match[1];
    } else {
	$file = $object;
    }
    if (preg_match("/(\.*)$/", $file, $match)) {
	$suffix = $match[1];
    } else {
	unset ($suffix);
    }
    if (!is_array($priv = $privileges[$this_user['usertype']])) {
	exception("Unknown usertype '" . $this_user['usertype'] . "'");
	die;
    }
    if ($op == "index") {
	if ($priv['allow'][$op]) {
	    return 1;
	}
    }
    if (is_array($deny_list = $priv['deny'][$op])) {
	if ($deny_list[$file]) {    // The file is rejected
	    if ($debug) {
		echo "The '$file' was explicitly rejected in file deny list";
	    }
	    return 0;
	}
	if (isset($suffix)) {				// Suffix is rejected
	    if ($deny_list["*$suffix"]) {
		if ($debug) {
		    echo "Suffix '$suffix' of the file '$file' was rejected";
		}
		return 0;
	    }
	}
    }
    if ($priv['allow'][$op] == "@portal") {
	return 1;
    }
    if ($priv['allow'][$op] == "@home") {
	if (!($area = $this_user['area'])) {
	    exception("Unset user area for user '" . $this_user['user'] . "'");
	    die;
	}
	$area = "$doc_root/$area";
	$area_regexp = make_regexp($area);
	if (preg_match("/^$area_regexp/", $cwd)) {
	    return 1;
	} else {
	    if ($debug) {
		echo "The file '$file' is outside user area '$area'";
	    }
	    return 0;
	}
    }
    return 0;		// We're paranoid, default grant is reject.
}


function check_auth_user ($no_header=0) {
    $user = $_SERVER['PHP_AUTH_USER'];
    $pwd = $_SERVER['PHP_AUTH_PW'];

    if (isset($user)) {
	if ($user_info = get_user_info($user)) {
	    if ($user_info['password'] != $pwd) {
		insert_auth_header();
	    }
	    setcookie ("tkl_admin", 1, 0, "/");
	    return $user_info;
	} else {
	    if ($no_header) {
		return 0;
	    } else {
		insert_auth_header();
	    }
	}
    } else {
	if ($no_header) {
	    return 0;
	} else {
	    insert_auth_header();
	}
    }
}


function insert_auth_header() {
    header("WWW-Authenticate: Basic realm=\"Toolkit Light - restricted areas\"");
    header("HTTP/1.0 401 Unauthorized");
    echo "HTTP/1.0 401 Unauthorized<br>";
    echo "You are attempting to enter a restricted area. Use proper login";
    exit;
}

function mkdir_ext ($dir) {
    $missing = array();
    while ($dir && !is_dir($dir)) {
	if (preg_match("/\/([^\/]*)$/", $dir, $match)) {
	    array_unshift($missing, $match[1]);
	    $dir = preg_replace("/\/[^\/]*$/", "", $dir);
	}

    }
    if ($dir) {
	foreach ($missing as $new_dir) {
	    $new = "$dir/$new_dir";
	    if (!mkdir($new, 0755)) {
		exception("Kunne ikke oprette kataloget '$new'");
		die;
	    }
	    $dir = $new;
	}
    } else {
	exception("Ingen sti tilbage");
	die;
    }
    return 1;
}


function recursive_copy ($src, $dest, $all_links = 0, $moved_links = 0) {
    global $debug, $doc_root;

    //if (!is_array($all_links)) {
	//get_links($_SERVER['DOCUMENT_ROOT'] . "/$doc_root", $all_links = array());
    //}
    //$src = preg_replace("/\/+$/", "", $src);

    if (!is_dir($dest)) {
	if (!mkdir_ext($dest)) {
	    return "Oprettelse af <b>$dest</b> mislykkedes";
	}
    }
    if ($dh = @opendir($src)) {
	while ($entry = readdir($dh)) {
	    if (neglect_file($entry)) {
		continue;
	    }
	    if (is_dir("$src/$entry")) {
		if ($msg = recursive_copy("$src/$entry", "$dest/$entry", $all_links, $moved_links)) {
		    return $msg;
		}
	    } elseif (is_link("$src/$entry")) {
	//	$moved_links["$src/$entry"] = "$dest/$entry";
	//	system("mv $src/$entry $dest/$entry");
	        return "Du skal fjerne links, inden du kan flytte hele kataloger...";
	    } else {
		if ($fh = fopen("$src/$entry", "a+")) {
		    if (flock($fh, LOCK_EX)) {
			$sys_src = check_chrs("$src/$entry");
			$sys_dest = check_chrs("$dest/$entry");
			system("cp $sys_src $sys_dest");
			//if (is_array($links = $all_links["$src/$entry"])) {
			//    foreach ($links as $link) {
			//	if (strlen($moved = $moved_links[$link])) {
			//	    $link = $moved;
			//	}
			//	system("rm -f $link");
			//	if (!symlink($sys_src, $link)) {
			//	    exception("Kunne ikke flyttet linket <em>$link</em>");
			//	    die;
			//	}
			//    }
			//}
			if ($debug) {
			    echo "Copying '$sys_src' to '$sys_dest'<br>";
			}
			fclose($fh);
		    } else {
			fclose($fh);
			return "Filen '$src/$entry' er i brug, prv igen lidt senere...";
		    }
		} else {
		    return "Kunne ikke f adgang til filen <b>$src/$entry</b>";
		}
	    }
	}
	closedir($dh);
    } else {
	return "Kataloget '$src' kunne ikke bnes, kontakt systemadminstrator...";
    }
}


function check_path ($path) {
    $apache_root = $_SERVER['DOCUMENT_ROOT'];
    $apache_root_regexp = "/^" . make_regexp($apache_root) . "\//";
    $abs_path = "$apache_root/$path";

    while (!file_exists("$abs_path/tkl.config")) {
	if (!($abs_path = preg_replace("/\/[^\/]*$/", "", $abs_path))) {
	    return 0;
	}
    }
    $rel_path = preg_replace($apache_root_regexp, "", $abs_path);

    return $rel_path;
}

function make_regexp ($str) {
    return preg_replace("/\//", "\/", $str);
}


function get_last_updated ($file) {
    if (file_exists($file)) {
	return date("Y-m-d, H:i:s", filemtime($file));
    }
}


function get_path ($here) {
    global $doc_root;

    $reg_doc_root = make_regexp($doc_root);
    $truncated = preg_replace("/^$reg_doc_root\/?/", "", $here);
    if (!$truncated) {
	    return array();
    } else {
	    return preg_split("/\//", $truncated);
    }
}


function insert_path ($script, $more="") {
    global $cwd, $doc_root, $context;

    $path = get_path($cwd);
    $acc_path = $doc_root;
    $sep = "&nbsp;&gt;&nbsp;";
    if ($cwd != $doc_root) {
	    echo "<a href=\"$script?", makeparms($context, array("cwd"=>$doc_root)), "$more\">Oversigt</a>";
    } else {
	    echo "Oversigt";
    }
    foreach ($path as $dir) {
    	$indexer = $_SERVER['DOCUMENT_ROOT'] . "/$acc_path/$dir/index.tkl";
    	if (file_exists($indexer)) {
    	    $show_dir = get_title($indexer);
    	    if (!strlen(trim($show_dir))) {
    		$show_dir = $dir;
    	    }
    	} else {
    	    $show_dir = $dir;
    	}
    	$acc_path .= "/$dir";
    	if ($acc_path != $cwd) {
    	    echo "$sep<a href=\"$script?", makeparms($context, array("cwd"=>$acc_path)), "$more\">$show_dir</a>";
    	} else {
    	    echo $sep, $show_dir;
    	}
    }
}

function extract_schema_old ($xml_file) {
    global $debug;
    $xml_schema = "";

    if ($debug) {
	    echo "Attempting to extract schema information from xml file '$xml_file'<br>";
    }
    if (!is_array($lines = file($xml_file))) {
    	echo "<b>Unable to open file '$xml_file'</b>";
    	die;
    }
    while ($line = array_shift($lines)) {		// Navigate to xml header
    	$line = trim($line);
    	if (preg_match("/<\?.*\?>/", $line)) {
    	    break;
    	}
    }
    while ($line = array_shift($lines)) {		// Find root tag
	$line = trim($line);
	if (!strlen($line)) {
	    continue;
	}
	//if (preg_match("/<(\S+)\s+(.*?)>/", $line, $match)) {
	if (preg_match("/<(\S+).*>/", $line, $match)) {
	    $root_tag = $match[1];
	    if ($debug) {
		echo "Identified root tag '$root_tag'<br>";
	    }
	    return "$root_tag.xsd";
	}
    }
    echo "<b>Identifikation af XML-schema for XML filen '$xml_file' mislykkedes</b>";
    return 0;
}


function extract_schema ($xml_file) {
    global $debug;
    $xml_schema = "";

    if ($debug) {
	    echo "Attempting to extract schema information from xml file '$xml_file'<br>";
    }
    if (!($dom = domxml_open_file($xml_file))) {
	echo "Can't open/parse xml file '$xml_file'";
	return "Unknown";
    }
    $doc = $dom->document_element();
    if (strlen($root_tag = $doc->tagname())) {
	if ($debug) {
	    echo "Identified root tag '$root_tag'<br>";
	}
	return "$root_tag.xsd";
    } else {
	echo "<b>Identifikation af XML-schema for XML filen '$xml_file' mislykkedes</b>";
	return "Unknown";
    }
}


function dir_content ($dir) {
    global $xml_suffix;
    $suffix_regexp = preg_replace("/\./", "\.", $xml_suffix);
    $content = array();

    if ($dh = @opendir($dir)) {
	while (strlen($entry = readdir($dh))) {
	    if (neglect_file($entry)) {
		continue;
	    }
	    if (is_dir("$dir/$entry")) {
		$content['dir'][] = $entry;
	    } else {
		if (preg_match("/$suffix_regexp$/", $entry)) {
		    $content['file'][] = $entry;
		}
	    }
	}
	closedir($dh);
	return $content;
    } else {
	exception("Kunne ikke <E5>bne kataloget '$dir'");
    }
}



function exception ($msg) {
    echo "<b>Fejl:</b> $msg";
    die;
}

function show_browse_results($id, $info, $type="") {
	global $context, $query, $selected_targets, $scan_map, $form_name, $field_name;

    $errno = yaz_errno($id);
    preg_match("/(\w+)=/", $query, $matches);
	$register = $matches[1];
	if ($errno == 0) {
        $ar = yaz_scan_result($id, &$options);
        while (list($key, list($k, $term, $tcount)) = each($ar)) {
            if (empty($k)) continue;
    			$use_term = check_term($term);
    			$register = preg_replace("/^l/", "", $register);
			if ($type == "getit") {
			    echo getitformat($term);
			} else {
                	    echo DK5format($term);
			}
    			echo "<BR>\n";
            }
        } else {
            echo "Scan failed. Error: " . yaz_error($id) . "<br>";
        }
}

//This function is used to format DK5 keyword strings.
function DK5format($term) {
	global $form_name, $field_name, $target, $field1;
	$string1 = " brug "; // Den rigtige tekst kommer EFTER string1
	$string2 = " brugt for "; // Den rigtige tekst kommer FR string2
	$string3 = " se ogs "; // Den rigtige tekst kommer FR string3 men der sges p ord efter. Kan repeteres.
	if (strpos($term,$string1)) {
		$start = strpos($term,$string1) + strlen($string1);
		$newterm = substr($term, $start);
		$newtermSub = ereg_replace("'","\\'",$newterm);
		echo substr($term, 0, $start - strlen($string1)). "<b>". substr($term, $start - strlen($string1), strlen($string1)). "</b><a href=\"getit.php?term1=$newtermSub&field1=$field1&field_name=$field_name&form_name=$form_name&server_name=$target\">$newterm</a>";
	} elseif (strpos($term,$string2)) {
		$end = strpos($term,$string2);
		$newterm = substr($term, 0, $end);
		$newtermSub = ereg_replace("'","\\'",$newterm);
		$reststreng = ereg_replace($string2," <B>brugt for</B> ",substr($term, $end + strlen($string2)));
		echo "<a href=\"getit.php?term1=$newtermSub&field1=$field1&field_name=$field_name&form_name=$form_name&target=$target\">$newterm</a> <b>" .substr($term, $end, strlen($string2)). "</b>$reststreng";
	} elseif (strpos($term,$string3)) {
		$begynd = 1;
		while (strpos($term,$string3) !== false) {
			if ($begynd) {
				$end = strpos($term, $string3);
				$newterm = substr($term, 0, $end);
				$newtermSub = ereg_replace("'","\\'",$newterm);
			 	$output = $output. "<a href=\"javascript: InsertTerm('$newtermSub','$form_name','$field_name','A')\">$newterm</a>";
//				$output = $output. "<a href=\"getit.php?term1=$newtermSub&field1=$field1&field_name=$field_name&form_name=$form_name&target=$target\">$newterm</a>";
			 	$begynd = 0;
			 	$term = substr($term, $end);
			 } else {
			 	$output = $output. "<b>". substr($term, 0, strlen($string3)). "</b>";
			 	$term = substr($term, strlen($string3));
			 	$end = strpos($term,$string3) - 3;
			 	$end2 = $end;
			 	if ($end <= -1) {
			 		$end = "end";
			 	} elseif ($end != "end") {
			 		$end = $end + 2;
			 		$end2 = $end++;
			 	}
			 	$altterm = substr($term, 0);
			 	$output = $output. " <a href=\"$PHP_SELF?target=$target&form_name=$form_name&field_name=$field_name&action=scan&scannumber=10&term1=$altterm\">$altterm</a>";
			 	$term = substr($term, $end);
			 }
		}
		echo $output;
	} else {
	    //regsub -all {([']+)} $term "\\'" termSub
	    $termSub = ereg_replace("'","\\'",$term);
		echo "<a href=\"javascript: InsertTerm('$termSub','$form_name','$field_name','A')\">$term</a>";
//		echo "<a href=\"getit.php?term1=$termSub&field1=$field1&field_name=$field_name&form_name=$form_name&target=$target\">$term</a>";
	}
	echo "";
}

// $Log: standards.php,v $
// Revision 1.66  2003/01/02 14:27:04  sondberg
// Now checking for tainted path user input.
//
// Revision 1.65  2002/12/12 12:22:38  sondberg
// Reintroduced strlen in dir_content.
//
// Revision 1.64  2002/12/12 11:05:17  sondberg
// Now the portal statistics is only carried out for tkl-files.
//
// Revision 1.62  2002/11/25 09:06:52  quinn
// Work
//
// Revision 1.61  2002/11/08 14:26:09  sondberg
// Corrected a bug in extract_schema. Now it relies on domxml.
//
// Revision 1.60  2002/10/23 12:39:31  perhans
// Made some changes that had to do with sending of emilas in case a URL is dead.
//
// Revision 1.59  2002/10/04 10:06:41  quinn
// Work
//
// Revision 1.58  2002/10/03 08:00:22  sondberg
// Dublet check reports if no server socket is present.
//
// Revision 1.57  2002/10/02 13:59:37  sondberg
// URL doublet check implemented.
//
// Revision 1.56  2002/09/16 10:55:51  quinn
// Null
//
// Revision 1.55  2002/09/16 10:37:42  sondberg
// When authenticated, a "tkl_admin" cookie is set.
//
// Revision 1.54  2002/09/13 08:53:12  adam
// Compatible DOMXML (PHP 4.1, 4.2 and 4.3 shold work)
//
// Revision 1.53  2002/09/12 19:15:37  sondberg
// No < > in fields other than xs:anyType.
//
// Revision 1.52  2002/09/12 10:08:18  sondberg
// Relative symbolic linking stable with respect to (re)moving of files.
//
// Revision 1.51  2002/09/11 10:36:16  sondberg
// Added optional $no_header in check_auth_user.
//
// Revision 1.50  2002/08/22 09:21:07  sondberg
// Symbolic links are not taking into account when producing record statistics.
//
// Revision 1.49  2002/08/16 08:41:34  sondberg
// Added functions qual_struct and qual_struct_process.
//
// Revision 1.48  2002/08/15 10:26:48  sondberg
// Added function escape_amp to handle &amp; entities. Implemented the support for
// xs:anyType to handle leaf-node xhtml.
//
// Revision 1.47  2002/07/31 08:03:48  sondberg
// Removed some debugging.
//
// Revision 1.46  2002/07/30 11:07:29  sondberg
// Reintroduced Seb's HTML changes.
//
// Revision 1.45  2002/07/29 08:34:06  perhans
// fixed another bug in get_metadata
//
// Revision 1.44  2002/07/29 08:19:53  perhans
// Corrected error in get_metadata
//
// Revision 1.43  2002/07/26 13:22:36  perhans
// Minor change.
//
// Revision 1.40  2002/07/25 14:13:55  sondberg
// Stat works again.
//
// Revision 1.39  2002/07/25 12:44:00  sondberg
// Re-re-introduced dir_content.
//
// Revision 1.38  2002/07/25 12:35:52  perhans
// Corrected small conflict
//
// Revision 1.37  2002/07/25 12:20:53  sondberg
// Escaping & in create_xml, and added two new functions, get_symb_links, set_symb_link.
//
// Revision 1.36  2002/07/25 08:08:09  perhans
// Extended insert_path to handle extra parameters in the URLs.
//
// Revision 1.35  2002/07/24 13:40:22  sondberg
// Implemented possibility of disabling the recursive nature of file_filter.
//
// Revision 1.34  2002/07/24 10:30:23  sondberg
// Reintroduced dir_content, disappeared for some reason, weird.
//
// Revision 1.33  2002/07/24 09:51:47  perhans
// Changed get_metadata to exclude dc: prefix in metadata names.
//
// Revision 1.32  2002/07/24 07:54:00  sondberg
// Added functions to help filtering files.
//
// Revision 1.31  2002/07/23 13:40:58  perhans
// Added the function get_metadata for extracting metadata out of a URL
//
// Revision 1.30  2002/07/23 08:45:14  sondberg
// Corrected bug with respect to suffixes.
//
// Revision 1.29  2002/07/22 14:33:56  sondberg
// Smallies.
//
// Revision 1.28  2002/07/22 13:52:11  sondberg
// Escaping ampersand.
//
// Revision 1.27  2002/07/22 12:32:34  quinn
// Various changes.
//
// Revision 1.26  2002/07/19 07:42:06  quinn
// Work
//
// Revision 1.25  2002/07/18 10:13:30  sondberg
// It is now possible to move directories.
//
// Revision 1.24  2002/07/18 09:12:04  perhans
// Moved create_struct from xform to here.
//
// Revision 1.23  2002/07/11 13:25:38  sondberg
// Removed debug msg.
//
// Revision 1.22  2002/07/11 13:17:02  sondberg
// Changed lang to xml:lang in get_title.
//
// Revision 1.21  2002/07/11 13:13:25  sondberg
// Changed get_title to extract title in correct language representation (according to $admin_lang).
//
// Revision 1.20  2002/07/10 14:00:29  sondberg
// Smallies.
//
// Revision 1.19  2002/07/09 10:35:26  sondberg
// Changed a bit in insert_path.
//
// Revision 1.18  2002/07/08 09:12:37  sondberg
// Neglecting dirs gfx.
//
// Revision 1.17  2002/07/05 16:22:03  sondberg
// Nothing.
//
// Revision 1.16  2002/07/05 14:37:14  sondberg
// User area is relative to portal root.
//
// Revision 1.15  2002/07/05 14:10:02  sondberg
// Added the is_granted function.
//
// Revision 1.14  2002/07/05 12:56:07  sondberg
// Included is_granted. Moved create_xml to standards.php.
//
// Revision 1.13  2002/07/04 16:48:58  sondberg
// Added various tools for authentication.
//
// Revision 1.12  2002/07/04 10:24:03  sondberg
// Corrected a bug in the change directory name functions.
//
// Revision 1.11  2002/07/04 09:42:44  sondberg
// Implemented a change dir name function.
//
// Revision 1.10  2002/07/03 16:13:32  sondberg
// Smallies.
//
// Revision 1.9  2002/07/03 13:40:43  sondberg
// Added a generic date/time stamp.
//
// Revision 1.8  2002/07/02 16:36:03  sondberg
// Moved default_file to standards.php.
//
// Revision 1.7  2002/07/02 16:10:57  sondberg
// Added some extra general functions, like make_regexp.
//
// Revision 1.6  2002/07/02 15:45:32  sondberg
// Added some tools to generate paths.
//
// Revision 1.5  2002/06/27 15:02:45  sondberg
// New procedure for extracting schema information from xml records.
//
// Revision 1.4  2002/06/21 10:58:58  sondberg
// Added the function extract_schema, which scans an xml record, finds the root tag and returns the schema content.
//
// Revision 1.3  2002/06/20 10:25:21  sondberg
// Included the function is_empty.
//
// Revision 1.2  2002/06/18 12:53:56  sondberg
// Added makeparms.
//
// Revision 1.1  2002/06/06 13:17:17  sondberg
// Placed the globals in config.php and prepared for global tools in standard.php.
//

?>
